// CE9500eep.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <string.h>
#include "windev.h"
#include "CE9500eep.h"
#include "ntddndis.h"
#include "nuiouser.h"

#define MAJOR_VER 1
#define MINOR_VER 1
#define DATECODE "02/24/2016"

// SCSRs
#define ETH_ID_REV                  (0x00UL)
	#define REV_CHIP_ID_		0x9500UL
	#define REV_CHIP_ID1_		0x9505UL
	#define REV_CHIP_ID_9514	0xEC00UL
	#define REV_CHIP_ID_9500A	0x9E00UL //9500A
	#define REV_CHIP_ID_9505A	0x9E01UL //9505A
	#define REV_CHIP_ID_9530	0x9530UL
    #define REV_CHIP_ID_9530_	0x9535UL
    #define REV_CHIP_ID_9730	0x9730UL
    #define REV_CHIP_ID_9730_	0x9735UL
    #define REV_CHIP_ID_89530	0x9e08UL
    #define REV_CHIP_ID_89530_	0x9e09UL
#define ETH_FPGA_REV                (0x04UL)
#define ETH_INT_STS                 (0x08UL)
#define ETH_RX_CFG                  (0x0CUL)
#define ETH_TX_CFG                  (0x10UL)
#define ETH_HW_CFG                  (0x14UL)
#define ETH_RX_FIFO_INF             (0x18UL)
#define ETH_TX_FIFO_INF             (0x1CUL)
#define ETH_PM_CTRL                 (0x20UL)
#define ETH_LED_GPIO_CFG            (0x24UL)
#define ETH_GPIO_CFG                (0x28UL)
#define ETH_AFC_CFG                 (0x2CUL)
#define ETH_E2P_CMD                 (0x30UL)
#define ETH_E2P_DATA                (0x34UL)
#define ETH_BURST_CAP               (0x38UL)
#define ETH_STRAP_DEBUG             (0x3CUL)
#define ETH_DP_SEL                  (0x40UL)
#define ETH_DP_CMD                  (0x44UL)
#define ETH_DP_ADDR                 (0x48UL)
#define ETH_DP_DATA0                (0x4CUL)
#define ETH_DP_DATA1                (0x50UL)
#define ETH_GPIO_WAKE               (0x64UL)
#define ETH_INT_EP_CTL              (0x68UL)
#define ETH_BULK_IN_DLY             (0x6CUL)

// MAC CSRs
#define MAC_CR                      (0x100UL)
#define ADDRH                       (0x104UL)
#define ADDRL                       (0x108UL)
#define HASHH                       (0x10CUL)
#define HASHL                       (0x110UL)
#define MII_ADDR                    (0x114UL)
#define MII_DATA                    (0x118UL)
#define FLOW                        (0x11CUL)
#define VLAN1                       (0x120UL)
#define VLAN2                       (0x124UL)
#define WUFF                        (0x128UL)
#define WUCSR                       (0x12CUL)
#define ETH_COE_CR                  (0x130UL)

////////////////////////////////////
// PHY Definitions
////////////////////////////////////
#define PHY_BMC_REG                 0
#define PHY_BMS_REG                 1     /* Basic Mode Status Register */
#define PHY_ID1_REG                 2     /* Phy Identifier register 1 */
#define PHY_ID2_REG                 3     /* Phy Identifier register 2 */
#define PHY_ANA_REG                 4
#define PHY_ANLPA_REG               5 
#define PHY_ANE_REG                 6     /* Auto-Negotiation Expansion Reg */
#define PHY_THERA_MODE_CTL_STS      17
#define PHY_THERA_SPECIAL_MODES     18
#define PHY_THERA_CTL_STS_IND       27
#define PHY_THERA_INT_SOURCE        29
#define PHY_THERA_INT_MASK          30
#define PHY_THERA_SPECIAL_REG       31

typedef struct _SCSR_Disp
{
    char name[50];
    DWORD offset;
}SCSR_Disp;

SCSR_Disp LanRegSet[] = {"ETH_ID_REV      ", ETH_ID_REV,
                         "ETH_FPGA_REV    ", ETH_FPGA_REV,
                         "ETH_INT_STS     ", ETH_INT_STS,
                         "ETH_RX_CFG      ", ETH_RX_CFG,
                         "ETH_TX_CFG      ", ETH_TX_CFG,
                         "ETH_HW_CFG      ", ETH_HW_CFG,
                         "ETH_RX_FIFO_INF ", ETH_RX_FIFO_INF,
                         "ETH_TX_FIFO_INF ", ETH_TX_FIFO_INF,
                         "ETH_PM_CTRL     ", ETH_PM_CTRL,
                         "ETH_LED_GPIO_CFG", ETH_LED_GPIO_CFG,
                         "ETH_GPIO_CFG    ", ETH_GPIO_CFG,
                         "ETH_AFC_CFG     ", ETH_AFC_CFG,
                         "ETH_E2P_CMD     ", ETH_E2P_CMD,
                         "ETH_BURST_CAP   ", ETH_BURST_CAP,
                         "ETH_STRAP_DEBUG ", ETH_STRAP_DEBUG,
                         "ETH_DP_SEL      ", ETH_DP_SEL,
                         "ETH_DP_CMD      ", ETH_DP_CMD,
                         "ETH_DP_ADDR     ", ETH_DP_ADDR,
                         "ETH_DP_DATA0    ", ETH_DP_DATA0,
                         "ETH_DP_DATA1    ", ETH_DP_DATA1,
                         "ETH_GPIO_WAKE   ", ETH_GPIO_WAKE,
                         "ETH_INT_EP_CTL  ", ETH_INT_EP_CTL,
                         "ETH_BULK_IN_DLY ", ETH_BULK_IN_DLY};

SCSR_Disp MacRegSet[] = {"MAC_CR    ", MAC_CR,
                         "ADDRH     ", ADDRH,
                         "ADDRL     ", ADDRL,
                         "HASHH     ", HASHH,
                         "HASHL     ", HASHL,
                         "MII_ADDR  ", MII_ADDR,
                         "MII_DATA  ", MII_DATA,
                         "FLOW      ", FLOW,
                         "VLAN1     ", VLAN1,
                         "VLAN2     ", VLAN2,
                         "WUFF      ", WUFF,
                         "WUCSR     ", WUCSR,
                         "ETH_COE_CR", ETH_COE_CR};

SCSR_Disp PhyRegSet[] = {"PHY_BMC_REG            ", PHY_BMC_REG,
                         "PHY_BMS_REG            ", PHY_BMS_REG,
                         "PHY_ID1_REG            ", PHY_ID1_REG,
                         "PHY_ID2_REG            ", PHY_ID2_REG,
                         "PHY_ANA_REG            ", PHY_ANA_REG,
                         "PHY_ANLPA_REG          ", PHY_ANLPA_REG,
                         "PHY_ANE_REG            ", PHY_ANE_REG,
                         "PHY_THERA_MODE_CTL_STS ", PHY_THERA_MODE_CTL_STS,
                         "PHY_THERA_SPECIAL_MODES", PHY_THERA_SPECIAL_MODES,
                         "PHY_THERA_CTL_STS_IND  ", PHY_THERA_CTL_STS_IND,
                         "PHY_THERA_INT_SOURCE   ", PHY_THERA_INT_SOURCE,
                         "PHY_THERA_INT_MASK     ", PHY_THERA_INT_MASK,
                         "PHY_THERA_SPECIAL_REG  ", PHY_THERA_SPECIAL_REG};

BOOL SendE2pCmd(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD cmd);
BOOL ReadE2p(HANDLE	hAdapter, PNDISUIO_QUERY_OID queryOID, WORD addr, BYTE *val);
BOOL WriteE2p(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, WORD addr, BYTE *val);
BOOL ReadBlockE2p(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD addr, DWORD length, BYTE *buf);
BOOL WriteBlockE2p(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD addr, DWORD length, BYTE *buf);
BOOL EraseE2p(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID);
BOOL LanReadRegDW(HANDLE hAdapter,  PNDISUIO_QUERY_OID queryOID, DWORD dwOffset, DWORD *dwVal);
BOOL LanWriteRegDW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwOffset, DWORD *dwVal);
BOOL PhyReadRegW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwOffset, DWORD *wVal);
BOOL PhyWriteRegW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwOffset, DWORD *wVal);
BOOL GetDriverVersion(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, void *Buf);
BOOL GetE2pSize (HANDLE	hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD*E2pSize);



BOOL SendE2pCmd(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD cmd)
{
    BOOL bRc;
	DWORD	dwOutSize;
    BYTE * p= &(queryOID->Data[0]);
		
    memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));	

	*(DWORD *)p=cmd;
	
	queryOID->Oid = OID_NDIS_SMSC_SEND_E2P_COMMAND;				
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_SET_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL);
	if ( !bRc )
	{
		PRINT_ERROR( "Error in DeviceIoControl (OID_NDIS_SMSC_SEND_E2P_COMMAND) : %d\n", GetLastError());
		return FALSE;
	}
	return TRUE;
}

BOOL ReadE2p(HANDLE	hAdapter, PNDISUIO_QUERY_OID queryOID, WORD addr, BYTE *val)
{
   	BOOL bRc;
    DWORD	dwOutSize;
	BYTE * p= &(queryOID->Data[0]);
	
    	memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));

	*(WORD *)p=addr;
				
	queryOID->Oid = OID_NDIS_SMSC_READ_E2P;				
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_QUERY_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL);
	if ( !bRc )
	{
		PRINT_ERROR( "Error in DeviceIoControl (OID_NDIS_SMSC_READ_E2P) : %d\n", GetLastError());
		return FALSE;
	}

    *val = queryOID->Data[0];
    return TRUE;
}

BOOL WriteE2p(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, WORD addr, BYTE *val)
{
    BOOL bRc;
    BYTE * p= &(queryOID->Data[0]);
    DWORD	dwOutSize;
    	
    // First Enable Eeprom Write
    if (SendE2pCmd(hAdapter,queryOID, E2P_CMD_EWEN) == FALSE)
    {
    	PRINT_ERROR ( "In WriteE2p(),Failed to send E2p Command E2P_CMD_EWEN\r\n");
        return FALSE;
    }

	memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));
	
	*(WORD *)p=addr;
	*(BYTE *)((WORD *)p+1)=*val;
	
   					
	queryOID->Oid = OID_NDIS_SMSC_WRITE_E2P;				
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_SET_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL);
    	
    if ( !bRc )
    {
        PRINT_ERROR ( "Error in DeviceIoControl (IOCTL_LAN9500_MP_ACCESS) : %d\n", GetLastError());
        // Before exit, make sure to reset eeprom write enable
        SendE2pCmd(hAdapter, queryOID,E2P_CMD_EWDS);
        return FALSE;
    }

    // Before exit, make sure to reset eeprom write enable
    if (SendE2pCmd(hAdapter, queryOID,E2P_CMD_EWDS) == FALSE)
   	{
   		PRINT_ERROR ( "In WriteE2p(),Failed to send E2p Command E2P_CMD_EWDS\n\n");
        return FALSE;
    }
	return TRUE;
}

BOOL ReadBlockE2p(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD length, BYTE *buf)
{
    BOOL bRc;
	BYTE * pE2pSize=&queryOID->Data[0];
    DWORD	dwOutSize;
		
    memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));
	*(DWORD *) pE2pSize=length;
					
	queryOID->Oid = OID_NDIS_SMSC_READ_E2P_BLOCK;				
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_QUERY_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL);
    if ( !bRc )
    {
        PRINT_ERROR ( "Error in DeviceIoControl (OID_NDIS_SMSC_READ_E2P_BLOCK) : %d\n", GetLastError());
       	return FALSE;
    }

    memcpy((void *)buf, (void *)&(queryOID->Data[0]), length);
    return TRUE;
}

BOOL WriteBlockE2p(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD length, BYTE *buf)
{
    BOOL bRc;
    DWORD	dwOutSize;

	// First Enable Eeprom Write
    if (SendE2pCmd(hAdapter, queryOID,E2P_CMD_EWEN) == FALSE)
    {	
    	PRINT_ERROR ( "In WriteBlockE2p, Error at SendE2pCmd(E2P_CMD_EWEN)");
   		return FALSE;
    }
		
 	memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));	
	memcpy( (void *)&(queryOID->Data[0]), (void *)buf,length+4);
	
	queryOID->Oid = OID_NDIS_SMSC_WRITE_E2P_BLOCK;				
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_SET_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL);
	
	if ( !bRc )
    {
        //printf ( "Error in DeviceIoControl (OID_NDIS_SMSC_WRITE_E2P_BLOCK) : %d\n", GetLastError());
        // Before exit, make sure to reset eeprom write enable
        SendE2pCmd(hAdapter, queryOID,E2P_CMD_EWDS);
        return FALSE;
    }

    // Before exit, make sure to reset eeprom write enable
    if (SendE2pCmd(hAdapter, queryOID,E2P_CMD_EWDS) == FALSE)
    {
    	PRINT_ERROR ( "In WriteBlockE2p, Error at SendE2pCmd(E2P_CMD_EWDS)");
        return FALSE;
    }
    return TRUE;
}

BOOL EraseE2p(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID)
{
   	if ( SendE2pCmd(hAdapter, queryOID,E2P_CMD_EWEN)==FALSE) {
		return FALSE;
	}		
	if ( SendE2pCmd(hAdapter, queryOID,E2P_CMD_ERAL)==FALSE) {
		return FALSE;
	}
	if ( SendE2pCmd(hAdapter, queryOID,E2P_CMD_EWDS)==FALSE) {
		return FALSE;
	}
	return TRUE;
}

BOOL Verify(DWORD Size, BYTE * rBuf, BYTE * wBuf)
{
	BOOL val=TRUE;
	DWORD j=0;
				
	for (j=0; j<Size; j++) {

		if  (rBuf[j+4] !=  wBuf[j+4])
		{	
			val=FALSE;
			break;
		}
	}
	return val;
}


BOOL LanReadRegDW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwOffset, DWORD *dwVal)
{
    BOOL bRc;
	BYTE * p=&(queryOID->Data[0]);
    DWORD	dwOutSize;
	   
    memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));	
	*(DWORD *)p=dwOffset;
			
	queryOID->Oid = OID_NDIS_SMSC_LAN_READ_REGS;
	
	bRc = DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_QUERY_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL); 
			
    if ( !bRc )
	{
		PRINT_ERROR("\nError in DeviceIoControl(),  OID_NDIS_SMSC_LAN_READ_REGS) \n\n\n");
        return FALSE;
    }

    *dwVal = *((DWORD *)&queryOID->Data[0]);
    return TRUE;
}

BOOL LanWriteRegDW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwOffset, DWORD *dwVal)
{
    BOOL bRc;
    BYTE *p= &(queryOID->Data[0]);
    DWORD	dwOutSize;

	memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));
	*(DWORD *)p=dwOffset;
	*(DWORD *)((DWORD *)p+1)=*dwVal;

	queryOID->Oid = OID_NDIS_SMSC_LAN_WRITE_REGS;

	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_SET_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL);
    if ( !bRc )
   	{
        PRINT_ERROR("\nError in DeviceIoControl(),  OID_NDIS_SMSC_LAN_WRITE_REGS) \n\n\n");
        return FALSE;
    }
    
    return TRUE;
}

BOOL PhyReadRegW(HANDLE	hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwOffset, DWORD *wVal)
{
    BOOL bRc;
    DWORD	dwOutSize;
    BYTE * p= &(queryOID->Data[0]);
    
    memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));
	*(DWORD *)p = dwOffset;
			
	queryOID->Oid = OID_NDIS_SMSC_PHY_READ_REGS;
	
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_QUERY_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL); 
			
    if ( !bRc )
   	{
        PRINT_ERROR("\nError in DeviceIoControl(),  OID_NDIS_SMSC_PHY_READ_REGS) \n\n\n");
        return FALSE;
    }

    *wVal = *(DWORD *)&queryOID->Data[0];
    return TRUE;
}

BOOL PhyWriteRegW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwOffset, DWORD *wVal)
{
    BOOL bRc;
    BYTE * p= &(queryOID->Data[0]);
    DWORD	dwOutSize;
    memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));
	*(DWORD *)p=dwOffset;
	*(DWORD *)((DWORD *)p+1)=*wVal;
		
	queryOID->Oid = OID_NDIS_SMSC_PHY_WRITE_REGS;
	
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_SET_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL);

    if ( !bRc )
   	{
        PRINT_ERROR("\nError in DeviceIoControl(),  OID_NDIS_SMSC_PHY_WRITE_REGS) \n\n\n");
        return FALSE;
    }
    
    return TRUE;
}

BOOL PhyReadAddressRegW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwPhyAddress, DWORD dwOffset, DWORD *wVal)
{
    BOOL bRc;
    DWORD dwOutSize;
    BYTE *p = &(queryOID->Data[0]);
    
    memset((void *)queryOID->Data, 0, (sizeof(queryOID->Data) + sizeof(queryOID->buf)));
	*(DWORD *)p = dwPhyAddress;
	*(DWORD *)((DWORD *)p+1) = dwOffset;
	*(DWORD *)((DWORD *)p+2) = 0; //Read only 16 bit value
			
	queryOID->Oid = OID_NDIS_SMSC_PHY_READ_REG_ADDRESS;
	
	bRc = DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_QUERY_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL); 
			
    if (!bRc)
   	{
        PRINT_ERROR("\nError in DeviceIoControl(),  OID_NDIS_SMSC_PHY_READ_REG_ADDRESS) \n\n\n");
        return FALSE;
    }

    *wVal = *(DWORD *)&queryOID->Data[0];
    return TRUE;
}

BOOL PhyWriteAddressRegW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwPhyAddress, DWORD dwOffset, DWORD *wVal)
{
    BOOL bRc;
    BYTE *p = &(queryOID->Data[0]);
    DWORD dwOutSize;
    memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));
	*(DWORD *)p = dwPhyAddress;
	*(DWORD *)((DWORD *)p+1) = dwOffset;
	*(DWORD *)((DWORD *)p+2) = *wVal;
	*(DWORD *)((DWORD *)p+3) = 0; //write only 16 bit value
		
	queryOID->Oid = OID_NDIS_SMSC_PHY_WRITE_REG_ADDRESS;
	
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_SET_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL);
			
    if ( !bRc )
   	{
        PRINT_ERROR("\nError in DeviceIoControl(),  OID_NDIS_SMSC_PHY_WRITE_REG_ADDRESS) \n\n\n");
        return FALSE;
    }
    
    return TRUE;
}

BOOL SMIPhyReadAddressRegW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwPhyAddress, DWORD dwOffset, DWORD *wVal)
{
    BOOL bRc;
    DWORD dwOutSize;
    BYTE *p = &(queryOID->Data[0]);
    
    memset((void *)queryOID->Data, 0, (sizeof(queryOID->Data) + sizeof(queryOID->buf)));
	*(DWORD *)p = dwPhyAddress;
	*(DWORD *)((DWORD *)p+1) = dwOffset;
	*(DWORD *)((DWORD *)p+2) = 1; //Read 32 bit value from SMI register
			
	queryOID->Oid = OID_NDIS_SMSC_PHY_READ_REG_ADDRESS;
	
	bRc = DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_QUERY_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL); 
			
    if (!bRc)
   	{
        PRINT_ERROR("\nError in DeviceIoControl(),  OID_NDIS_SMSC_PHY_READ_REG_ADDRESS) \n\n\n");
        return FALSE;
    }

    *wVal = *(DWORD *)&queryOID->Data[0];
    return TRUE;
}

BOOL SMIPhyWriteAddressRegW(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD dwPhyAddress, DWORD dwOffset, DWORD *wVal)
{
    BOOL bRc;
    BYTE *p = &(queryOID->Data[0]);
    DWORD dwOutSize;
    memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));
	*(DWORD *)p = dwPhyAddress;
	*(DWORD *)((DWORD *)p+1) = dwOffset;
	*(DWORD *)((DWORD *)p+2) = *wVal;
	*(DWORD *)((DWORD *)p+3) = 1; //write 32 bit value to SMI register
		
	queryOID->Oid = OID_NDIS_SMSC_PHY_WRITE_REG_ADDRESS;
	
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_SET_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL);
			
    if ( !bRc )
   	{
        PRINT_ERROR("\nError in DeviceIoControl(),  OID_NDIS_SMSC_PHY_WRITE_REG_ADDRESS) \n\n\n");
        return FALSE;
    }
    
    return TRUE;
}

BOOL GetDriverVersion(HANDLE hAdapter, PNDISUIO_QUERY_OID queryOID,void * pBuf)
{
    BOOL bRc;
    DWORD	dwOutSize;
		
    memset((void *)queryOID->Data,0,(sizeof(queryOID->Data)+sizeof(queryOID->buf)));	
		
	queryOID->Oid = OID_NDIS_SMSC_GET_DRIVER_INFO;
	
	bRc=DeviceIoControl(hAdapter,
			IOCTL_NDISUIO_QUERY_OID_VALUE, 
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			(LPVOID)queryOID,
			sizeof(NDISUIO_QUERY_OID) + sizeof(DWORD),
			&dwOutSize, NULL); 
				
    if ( !bRc )
   	{
        PRINT_ERROR("\nError in DeviceIoControl(),  OID_NDIS_SMSC_GET_DRIVER_INFO) \n\n\n");
        return FALSE;
    }

	memcpy(pBuf, (void *)&queryOID->Data[0], 4*sizeof(DWORD));

    	return TRUE;
}


BOOL GetE2pSize(HANDLE	hAdapter, PNDISUIO_QUERY_OID queryOID, DWORD *pE2pSize)
{
    DWORD dwTemp,dwValue;
    BOOL IsTheraChipId=FALSE; 
      
    	// Read ETH_STRAP_DEBUG
   	 if (LanReadRegDW(hAdapter,queryOID, ETH_ID_REV , &dwValue) == FALSE)
    {
    		PRINT_ERROR("\nIn GetE2pSize(), Error in LanReadRegDW(ETH_ID_REV ) \n\n\n");
        	return FALSE;
    }
    if ((dwValue&0XFF000000) == 0x95000000){
		IsTheraChipId=TRUE;
    }
	
    if (IsTheraChipId)
    {
   		 // Read ETH_STRAP_DEBUG
   	 	if (LanReadRegDW(hAdapter,queryOID, ETH_STRAP_DEBUG, &dwTemp) == FALSE)
   		{
   		 	PRINT_ERROR("\nIn GetE2pSize(), Error in LanReadRegDW(ETH_STRAP_DEBUG) \n\n\n");
        		return FALSE;
   	 	}
		
    		// Check EEPROM Disable strap
    	if (dwTemp & 0x1UL)
    	{
    		PRINT_WARNING("EEPROM Disable Strap is set!\n");
        	return FALSE;
    	}
    }

    // Check EEPROM SIZE strap value
    if (IsTheraChipId &&(!(dwTemp & 0x4UL))) // 128-byte eeprom
    {
        	*pE2pSize = 128;
        	return TRUE;
    }  	
    else
    {
        // Check to see if it is 256-byte E2P
        BYTE bStart, bEnd, bTemp;

        if (ReadE2p(hAdapter,queryOID, 0, &bStart) == FALSE)
        {
            return FALSE;
        }
	
        if (ReadE2p(hAdapter,queryOID, 256, &bEnd) == FALSE)
        {
            return FALSE;
        }
	
        // Write to 256 the inverse value of bStart
        bTemp = ~bStart;
        if (WriteE2p(hAdapter,queryOID, 256, &bTemp) == FALSE)
        {
            return FALSE;
        }
        
        // Now read locatiion zero again
        if (ReadE2p(hAdapter, queryOID,0, &bTemp) == FALSE)
        {
            return FALSE;
        }

        if (bTemp != bStart) // 256-byte E2P
        {
            // Rewrite correct value into location 0
            if (WriteE2p(hAdapter,queryOID, 0, &bStart) == FALSE)
            {
                return FALSE;
            }
			      
            *pE2pSize = 256;
            return TRUE;
        }
        else // 512-byte E2P
        {
            // Rewrite correct value into location 256
            if (WriteE2p(hAdapter,queryOID, 256, &bEnd) == FALSE)
            {
                return FALSE;
            }

            *pE2pSize = 512;
            return TRUE;
        }
    }
}

int VerifyEeprom(BYTE * pEeprom, int size,PNDISUIO_QUERY_OID queryOID, HANDLE hDevice)
{
	BYTE deviceEEPROM[516];
	int retVal = SUCCESS;
	int i;

	if(size > MAX_EEPROM_SIZE){
		PRINT_MSG("Invalid eeprom size\n");
		return ERROR_INVALIDEEPROMSIZE;
	}
	
	if(!ReadBlockE2p(hDevice, queryOID, size, deviceEEPROM)){
		PRINT_MSG("Failed to read eeprom\n");
		retVal = ERROR_EEPROMACCESS;
			
	}
	
	if(retVal != SUCCESS){
		return retVal;
	}
	for(i=0; i<size; i++){
		if(pEeprom[i] != deviceEEPROM[i]){
			retVal = ERROR_FAIL;
			PRINT_MSG("Failed to verify eeprom contents\n");
			break;
		}
	}

	return retVal;
}

int getOpt(int argc,  char * argv[], int *strCnt,  char ** optStr)
{
	int opt = 0,i=0,j=0,n=0;
	if(*strCnt >= argc) {
		return 0;
		}
	if(argv[*strCnt] == NULL) {
		PRINT_ERROR("argv is NULL");
		 return 0;
		}
		
	*optStr = NULL;

	while(*strCnt < argc){
		if(argv[*strCnt][0] == '-'){
			if(argv[*strCnt][1] == '\0'){
				*strCnt += 1;
				continue;
			}
			opt = argv[*strCnt][1];
			if((*strCnt + 1) < argc){
				if((argv[*strCnt+1] != NULL) && (argv[*strCnt+1][0] != '-')){
					*optStr =argv[*strCnt+1];
					*strCnt += 2;
					break;
				}else{
					*strCnt += 1;
					break;
				}
			}else *strCnt += 1;
		}else{
			*strCnt += 1;
		}
	}

    return opt;
}

BOOLEAN HexStrToDword(const char * const szBuf, DWORD *pdwVal)
{
	int i, iNumDigits;
	size_t uLen;
	DWORD dwVal = 0UL, dwTemp;

	// if string empty, fail
	if ((int)szBuf[0] == '\0')
	{
		printf("  ERROR:  HexStrToDword:  empty string\n");
		return FALSE;
	}

	// if string too long, would overflow, so skip it
	uLen = strlen(szBuf);
	if (uLen > 10U)
	{
		printf("  ERROR:  HexStrToDword:  bad strlen=%u\n", uLen);
		return FALSE;
	}


	// work left-to-right through the string building the DWORD result
	iNumDigits = 0;
	for (i=0; i<(int)uLen; i++)
	{
		if ((i == 0) && (szBuf[i] == '0') && (uLen != 1))
			continue;
		if ((i == 1) && ((szBuf[i] == 'x') || (szBuf[i] == 'X')))
			continue;

		if (szBuf[i] != '_')	// skip underscores
		{
			int	iTemp;

			if (isdigit((int)szBuf[i])) // 0-9
			{
				// put in next digit
// Keep ST20 happy
//				dwTemp = (DWORD)((int)szBuf[i] - '0');
				iTemp = (int)szBuf[i] - '0';
				dwTemp = (DWORD)(unsigned)iTemp;
			}
			else if ((szBuf[i] >= 'A') && (szBuf[i] <= 'F'))
			{
				// put in next upper-case digit
// Keep ST20 happy
//				dwTemp = (DWORD)((int)szBuf[i] - 'A') + 0x0AUL;
				iTemp = (int)szBuf[i] - 'A';
				dwTemp = (DWORD)(unsigned)iTemp + 0x0AUL;
			}
			else if ((szBuf[i] >= 'a') && (szBuf[i] <= 'f'))
			{
				// put in next lower-case digit
// Keep ST20 happy
//				dwTemp = (DWORD)((int)szBuf[i] - 'a') + 0x0AUL;
				iTemp = (int)szBuf[i] - 'a';
				dwTemp = (DWORD)(unsigned)iTemp + 0x0AUL;
			}
			else
			{
				// non-hex character, so fail
				printf("  ERROR:  HexStrToDword, bad char szBuf[%d]=0x%02X\n", i, szBuf[i]);
				return FALSE;
			}

			// shift previous digits 1 nibble left & insert current digit in low nibble
			dwVal = (dwVal <<4) + dwTemp;

			// keep track of how many digits we have
			iNumDigits++;
		}
		else
		{
			if (iNumDigits != 4)
			{
				// underscore, but not between upper/lower DWORD
				printf("  ERROR:  HexStrToDword, underscore must be between upper/lower words\n");
				return FALSE;
			}
		}
	}

	// if we got here, we succeeded, so return result and success status
	*pdwVal = dwVal;

	// if we didn't get exactly 8 digits, then it was a bad string
	if ((iNumDigits<1) || (iNumDigits > 8))
	{
		printf("  ERROR:  HexStrToDword:  bad #digits =%d (s/b <= 8)\n", iNumDigits);
		return FALSE;
	}

	return TRUE;
}
void *mem_set(void *pvDest, int iVal, size_t uCount)
{
	const unsigned char bVal = (unsigned char)(iVal & 0x00FF);
	unsigned char *pbDest = (unsigned char *)pvDest;
	size_t uI;

	for (uI=0U; uI<uCount; uI++) 
	{
		*pbDest++ = bVal;
	}	

	return pvDest;
}

int ConvertToHex(char c){
	int ret = 0;
	if(c >= '0' && c <= '9')
		ret = c - '0';
	else if(c >= 'a' && c <= 'f'){
		ret = c - 'a';
		ret += 10;
	}else if(c >= 'A' && c <= 'F'){
		ret = c - 'A';
		ret += 10;
	}else ret = -1;

	return ret;
}

char ConvertHexToChar(char hex_digit){
	char ret = 0;

	hex_digit &= 0x0F;

	if(hex_digit < 10){
		ret = hex_digit + '0';
	}else{
		ret = hex_digit - 10 + 'A';
	}

	return ret;
}

int GetMacAddr(unsigned char mac[], char *value)
{
	int ret = SUCCESS;
	int cnt = 0;
	char number[3];
	int high, low, i;
	int size = strlen(value);

	number[2] = '\0';
	for(i=0; i<6; i++){
		if(i < 5){
			if((size - cnt) < 3){
				ret = ERROR_FAIL;
				break;
			}else if((value[cnt+2] != ':') && (value[cnt+2] != '-')){
				ret = ERROR_FAIL;
				break;
			}
		}else if(i == 5){
			if((size - cnt) != 2){
				ret = ERROR_FAIL;
				break;
			}
		}
		high = ConvertToHex(value[cnt]);
		low = ConvertToHex(value[cnt+1]);
		cnt += 3;
		if(high >=0 && low >= 0){
			mac[i] = (char)((high << 4) | low);
		}else{
			ret = ERROR_FAIL;
			break;
		}
	}

	return ret;
}

int convertToCapital(char serial[])
{
	int cnt = 0;
	while(serial[cnt] != '\0'){
		if(serial[cnt] >= 'a' && serial[cnt] <= 'f'){
			serial[cnt] -= 32; //convert to capital
		}
		if(!((serial[cnt] >= '0' && serial[cnt] <= '9') || (serial[cnt] >= 'A' && serial[cnt] <= 'F'))){ //Not a Hex number
			return ERROR_FAIL;
		}
		cnt++;
	}

	return SUCCESS;
}

int convertMacToCapital(unsigned char mac[])
{
	int cnt = 0;
	while(mac[cnt] != '\0'){
		if(mac[cnt] >= 'a' && mac[cnt] <= 'f'){
			mac[cnt] -= 32; //convert to capital
		}
		cnt++;
	}

	return SUCCESS;
}

/* Decimal sanity check and remove space or tab at the end of string*/
int SanityCheckDecimal(char *string, unsigned int len_limit)
{
	int retVal = SUCCESS;
	int cnt = 0;

	ASSERT(string != NULL);

	while(string[cnt] != '\0'){//Sanity check
		if(string[cnt] == 0x20 || string[cnt] == 0x09){//space or tab
			string[cnt] = '\0';
			break;
		}else if(string[cnt] < '0' || string[cnt] > '9'){
			return ERROR_FAIL;
		}
		cnt++;
	}

	if(strlen(string) > len_limit){
		return ERROR_FAIL;
	}

	return retVal;
}

/*Compare two mac address
 * return: 1:	mac1 > mac2
 * 		   0:   mac1 = mac2
 * 		   -1: mac1 < mac2
 * */
int cmpMac(unsigned char mac1[], unsigned char mac2[], int cnt)
{
	int retVal;

	if(cnt == 0)return 0;

	if((unsigned char)mac1[0] > (unsigned char)mac2[0]){
		retVal = 1;
	}else if((int)mac1[0] < (int)mac2[0]){
		retVal = -1;
	}else{//It is equal
		mac1++;
		mac2++;
		retVal = cmpMac(mac1, mac2, cnt - 1);
	}

	return retVal;
}

static int VerifyMacRange(unsigned char mac[]){

	int retVal = TRUE;

	unsigned char mac_zero[6] = {0,0,0,0,0,0};

	if(mac[0] & 0x01){//Multicast or broadcast mac address
		retVal = FALSE;
	}else if(!cmpMac(mac, mac_zero, 6)){
		retVal = FALSE;
	}

	return retVal;
}

/*Increase by inc, max increment is 255*/
/*return value, TRUE: overflow; FALSE: ok */
int IncreaseMac(unsigned char mac[], unsigned int inc)
{
	int retVal = FALSE;
	int i;
	unsigned char temp;

	if(inc > 0xff){
		PRINT_ERROR("Mac address increment cannot exceed %d\n", MAX_INCREMENT);
		return retVal;
	}

	temp = (unsigned char)mac[5] + inc;
	if(temp >= (unsigned char)mac[5]){//not overflow
		mac[5] = temp;
		return retVal;
	}
	mac[5] = temp;
	for(i=4; i>=0; i--){
		mac[i]++;
		if(mac[i])break;
		else{
			if(i==0)retVal = TRUE; //Overflow
		}
	}

	return retVal;
}

/*Increase by inc, max increment is 255*/
/*
 *return value, TRUE: overflow; FALSE: ok */
int IncreaseSerial(char serial[], unsigned int inc)
{
	int retVal = FALSE;
	int length = strlen(serial);
	int i;
	unsigned char temp = 0, save;

	if(inc > 0xff){
		PRINT_ERROR("Serial number increment cannot exceed %d\n", MAX_INCREMENT);
		return retVal;
	}
	if(length == 1){
		temp = ConvertToHex(serial[0]);
		temp += inc;
		if(temp > 0x0F){
			retVal = TRUE;
		}
		serial[0] = ConvertHexToChar(temp);
	}else if(length >= 2){
		temp = ConvertToHex(serial[length-2]);
		temp <<= 4;
		temp |= ConvertToHex(serial[length-1]);

		save = temp;
		temp += inc;
		if(temp <= save){//overflow
			retVal = TRUE;
		}
		serial[length-1] = ConvertHexToChar(temp & 0x0F);
		serial[length-2] = ConvertHexToChar(temp >> 4);

		if(length > 2 && retVal){
			retVal = FALSE;
			for(i=length-3; i>=0; i--){
				if(serial[i] == '9')serial[i] = 'A';
				else if(serial[i] == 'F'){
					serial[i] = '0';
					if(i == 0){
						retVal = TRUE; //Overflow
					}
				}
				else serial[i]++;

				if(serial[i] != '0')break;
			}
		}
	}

	return retVal;
}

int cmpSerial(unsigned char serial1[], unsigned char serial2[], int cnt)
{
	int retVal;
	int digit1, digit2;

	if(serial1[0] >= 'A' && serial1[0] >= 'F'){
		digit1 = serial1[0] - 'A';
	}else if(serial1[0] >= 'a' && serial1[0] >= 'f'){
		digit1 = serial1[0] - 'a';
	}else if(serial1[0] >= '0' && serial1[0] >= '9'){
		digit1 = serial1[0] - '0';
	}
	if(serial2[0] >= 'A' && serial2[0] >= 'F'){
		digit2 = serial2[0] - 'A';
	}else if(serial2[0] >= 'a' && serial2[0] >= 'f'){
		digit2 = serial2[0] - 'a';
	}else if(serial2[0] >= '0' && serial2[0] >= '9'){
		digit2 = serial2[0] - '0';
	}

	if(digit1 > digit2){
		retVal = 1;
	}else if(digit1 < digit2){
		retVal = -1;
	}else{//It is equal
		if(!cnt)
			retVal = 0;
		else{
			serial1++;
			serial2++;
			retVal = cmpSerial(serial1, serial2, cnt - 1);
		}
	}

	return retVal;
}

/*Parse string  from binary */
int getString(PE2P_STRUCT eeprom, PEEPROM_CONTENT pContent)
{
	int i;
	int retVal = SUCCESS;

	if(eeprom->format.ManufacturerStrLen){
		if(pContent->ManufactureString)free(pContent->ManufactureString);
		pContent->ManufactureString = (char*)malloc(eeprom->format.ManufacturerStrLen/2);
		if(!pContent->ManufactureString){
			PRINT_WARNING("No enough memory");
			retVal = ERROR_NOMEM;
			goto _EXIT;
		}
		for(i=0; i<(eeprom->format.ManufacturerStrLen/2-1); i++)
			pContent->ManufactureString[i] = (char)eeprom->WBuf[eeprom->format.ManufacturerStrOffset + 1 + i];
		pContent->ManufactureString[(int)(eeprom->format.ManufacturerStrLen/2-1)] = '\0';
	}

	if(eeprom->format.ProductStrLen){
		if(pContent->ProductString)free(pContent->ProductString);
		pContent->ProductString = (char*)malloc(eeprom->format.ProductStrLen/2);
		if(!pContent->ProductString){
			PRINT_WARNING("No enough memory");
			retVal = ERROR_NOMEM;
			goto _EXIT;
		}

		for(i=0; i<(eeprom->format.ProductStrLen/2-1); i++)
			pContent->ProductString[i] = (char)eeprom->WBuf[eeprom->format.ProductStrOffset + 1 + i];
		pContent->ProductString[(int)(eeprom->format.ProductStrLen/2-1)] = '\0';
	}

	if(eeprom->format.SerialNumberStrLen){
		if(pContent->curSerialNum)free(pContent->curSerialNum);
		pContent->curSerialNum = (char*)malloc(eeprom->format.SerialNumberStrLen/2);
		if(!pContent->curSerialNum){
			PRINT_WARNING("No enough memory");
			retVal = ERROR_NOMEM;
			goto _EXIT;
		}

		for(i=0; i<(eeprom->format.SerialNumberStrLen/2-1); i++)
			pContent->curSerialNum[i] = (char)eeprom->WBuf[eeprom->format.SerialNumberStrOffset + 1 + i];
		pContent->curSerialNum[(int)eeprom->format.SerialNumberStrLen/2-1] = '\0';
	}

	if(eeprom->format.ConfigStrLen){
		if(pContent->ConfigurationString)free(pContent->ConfigurationString);
		pContent->ConfigurationString = (char*)malloc(eeprom->format.ConfigStrLen/2);
		if(!pContent->ConfigurationString){
			PRINT_WARNING("No enough memory");
			retVal = ERROR_NOMEM;
			goto _EXIT;
		}

		for(i=0; i<(eeprom->format.ConfigStrLen/2-1); i++)
			pContent->ConfigurationString[i] = (char)eeprom->WBuf[eeprom->format.ConfigStrOffset + 1 + i];
		pContent->ConfigurationString[(int)eeprom->format.ConfigStrLen/2-1] = '\0';
	}

	if(eeprom->format.InterfaceStrLen){
		if(pContent->InterfaceString)free(pContent->InterfaceString);
		pContent->InterfaceString = (char*)malloc(eeprom->format.InterfaceStrLen/2);
		if(!pContent->InterfaceString){
			PRINT_WARNING("No enough memory");
			retVal = ERROR_NOMEM;
			goto _EXIT;
		}
		for(i=0; i<(eeprom->format.InterfaceStrLen/2-1); i++)
			pContent->InterfaceString[i] = (char)eeprom->WBuf[eeprom->format.InterfaceStrOffset + 1 + i];
		pContent->InterfaceString[(int)eeprom->format.InterfaceStrLen/2-1] = '\0';
	}
_EXIT:
	return retVal;
}


/*Return value:
 * 			TRUE:	Max mac address and serial number doesn't reach
 * 			FALSE:	Finished
 */
int UpdateIncrement(PEEPROM_CONTENT pContent)
{
	int ret = TRUE;
	int result;

	if(!pContent->macIncrement && !pContent->serialIncrement){
		return FALSE;
	}

	if(pContent->macIncrement){
		result = IncreaseMac(pContent->curMacAddr, pContent->macIncrement);
		if(result){//Overflow
			PRINT_MSG("MAC address overflow\n");
			ret = FALSE;
			return FALSE;
		}

		if(cmpMac(pContent->curMacAddr, pContent->maxMacAddr, 6) > 0){//bigger
			PRINT_MSG("Reach maximum MAC address\n");
			ret = FALSE;
		}
	}

	if(pContent->serialIncrement){
		result = IncreaseSerial(pContent->curSerialNum, pContent->serialIncrement);
		if(result){//Overflow
			PRINT_MSG("Serial number overflow\n");
			ret = FALSE;
			return FALSE;
		}
		if(pContent->maxSerialNum){
			if(strcmp(pContent->curSerialNum, pContent->maxSerialNum) > 0){
				PRINT_MSG("Reach maximum serial number\n");
				ret = FALSE;
			}
		}
	}

	return ret;
}

int GenerateStringField(PEEPROM_CONTENT pContent, PE2P_STRUCT eeprom, int offset)
{
	int strLen, i;
	WORD wtemp;
	int retVal = SUCCESS;
	int maxOffset = pContent->eeprom_size / 2; //word offset

	// Manufacturer string
	 /* offset = ((int)(eeprom->format.UnicodeStr) - (int)(eeprom->E2pBuf)); */
	 offset = offset / 2;
	 if (pContent->ManufactureString) {
		 strLen = (strlen(pContent->ManufactureString ) + 1) * 2;
		 eeprom->format.ManufacturerStrLen = strLen;
		 eeprom->format.ManufacturerStrOffset = offset;
		 wtemp = 3 << 8;
		 wtemp |= strLen;
		 eeprom->WBuf[offset++] = wtemp;
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
		 for ( i = 0;   pContent->ManufactureString[i] != '\0';   i++ ){
			 if(offset >= maxOffset){
				 retVal = ERROR_FAIL;
				 goto _EXIT;
			 }
			eeprom->WBuf[offset++] = pContent->ManufactureString[i];
		 }
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
	 } else {
		eeprom->format.ManufacturerStrLen = 0;
		eeprom->format.ManufacturerStrOffset = 0;
	 }

	 // Product string
	 if (pContent->ProductString) {
		 strLen = (strlen( pContent->ProductString ) + 1) * 2;
		 eeprom->format.ProductStrLen = strLen;
		 eeprom->format.ProductStrOffset = offset;
		 wtemp = 3 << 8;
		 wtemp |= strLen;
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
		 eeprom->WBuf[offset++] = wtemp;
		 for ( i = 0;   pContent->ProductString[i] != '\0';   i++ ){
			 if(offset >= maxOffset){
				 retVal = ERROR_FAIL;
				 goto _EXIT;
			 }
			eeprom->WBuf[offset++] = pContent->ProductString[i];
		 }
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
	 } else {
		eeprom->format.ProductStrLen = 0;
		eeprom->format.ProductStrOffset = 0;
	 }

	 // Serial number string
	 if (pContent->curSerialNum) {
		 strLen = (strlen( pContent->curSerialNum ) + 1) * 2;
		 eeprom->format.SerialNumberStrLen = strLen;
		 eeprom->format.SerialNumberStrOffset = offset;
		 wtemp = 3 << 8;
		 wtemp |= strLen;
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
		 eeprom->WBuf[offset++] = wtemp;
		 for ( i = 0;   pContent->curSerialNum[i] != '\0';   i++ ){
			 if(offset >= maxOffset){
				 retVal = ERROR_FAIL;
				 goto _EXIT;
			 }
			eeprom->WBuf[offset++] = pContent->curSerialNum[i];
		 }
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
	 } else {
		eeprom->format.SerialNumberStrLen = 0;
		eeprom->format.SerialNumberStrOffset = 0;
	 }

	 // Configuration string
	 if (pContent->ConfigurationString) {
		 strLen = (strlen( pContent->ConfigurationString ) + 1) * 2;
		 eeprom->format.ConfigStrLen = strLen;
		 eeprom->format.ConfigStrOffset = offset;
		 wtemp = 3 << 8;
		 wtemp |= strLen;
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
		 eeprom->WBuf[offset++] = wtemp;
		 for ( i = 0;   pContent->ConfigurationString[i] != '\0';   i++ ){
			 if(offset >= maxOffset){
				 retVal = ERROR_FAIL;
				 goto _EXIT;
			 }
			eeprom->WBuf[offset++] = pContent->ConfigurationString[i];
		 }
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
	 } else {
		eeprom->format.ConfigStrLen = 0;
		eeprom->format.ConfigStrOffset = 0;
	 }

	 // Interface string
	 if (pContent->InterfaceString) {
		 strLen = (strlen( pContent->InterfaceString ) + 1) * 2;
		 eeprom->format.InterfaceStrLen = strLen;
		 eeprom->format.InterfaceStrOffset = offset;
		 wtemp = 3 << 8;
		 wtemp |= strLen;
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
		 eeprom->WBuf[offset++] = wtemp;
		 for ( i = 0;   pContent->InterfaceString[i] != '\0';   i++ ){
			 if(offset >= maxOffset){
				 retVal = ERROR_FAIL;
				 goto _EXIT;
			 }
			eeprom->WBuf[offset++] = pContent->InterfaceString[i];
		 }
		 if(offset >= maxOffset){
			 retVal = ERROR_FAIL;
			 goto _EXIT;
		 }
	 } else {
		eeprom->format.InterfaceStrLen = 0;
		eeprom->format.InterfaceStrOffset = 0;
	 }

	 pContent->real_size = offset * 2;
_EXIT:

	if(retVal == ERROR_FAIL){
		PRINT_WARNING("The size of generated binary is greater than EEPROM size(%dBytes)\n", pContent->eeprom_size);
	}

	 return retVal;
}

void CleanEEPROMStruct(PEEPROM_CONTENT pContent)
{
	if(pContent->curSerialNum){ free(pContent->curSerialNum); pContent->curSerialNum = NULL;}
	if(pContent->maxSerialNum){ free(pContent->maxSerialNum); pContent->maxSerialNum = NULL; }
	if(pContent->ManufactureString){ free(pContent->ManufactureString); pContent->ManufactureString = NULL;}
	if(pContent->ProductString) { free(pContent->ProductString); pContent->ProductString = NULL; }
	if(pContent->ConfigurationString){ free(pContent->ConfigurationString); pContent->ConfigurationString = NULL;}
	if(pContent->InterfaceString){ free(pContent->InterfaceString); pContent->InterfaceString = NULL; }

	if(pContent->eepromFileName){ free(pContent->eepromFileName); pContent->eepromFileName = NULL;}
	if(pContent->iniFilename){ free(pContent->iniFilename); pContent->iniFilename = NULL; }
}

/*Update mac and serial number*/
int ModifyEEPROMImage(PE2P_STRUCT eeprom, unsigned char *macAddress, char *serialNumber, int eeprom_size)
{
	int retVal = SUCCESS;
	int i, offset;
	EEPROM_CONTENT content;

	memset(&content, 0, sizeof(EEPROM_CONTENT));
	content.eeprom_size = eeprom_size;
	if(macAddress){
		for(i=0; i<6; i++)
			eeprom->format.MacAddr[i] = macAddress[i];
	}

	if(serialNumber){
		if(strlen(serialNumber) != (eeprom->format.SerialNumberStrLen/2-1)){//regenerate string fields
			int stringOffset = 0;
			retVal = getString(eeprom, &content);
			if(retVal != SUCCESS){
				goto _EXIT;
			}
			if(content.curSerialNum)free(content.curSerialNum);
			content.curSerialNum = (char *)malloc(strlen(serialNumber) + 1);
			if(!content.curSerialNum){
				PRINT_WARNING("No enough memory");
				retVal = ERROR_NOMEM;
				goto _EXIT;
			}
			strcpy(content.curSerialNum, serialNumber);
			if ((gScannedChipid >> 16) == REV_CHIP_ID_) {
				stringOffset = ((int)(eeprom->format.UnicodeStr) - (int)(eeprom->E2pBuf));
			} else if (((gScannedChipid >> 16)== REV_CHIP_ID_9500A) || ((gScannedChipid >> 16)== REV_CHIP_ID_9500A)) {
				stringOffset = ((int)(eeprom->format9500A.UnicodeStr) - (int)(eeprom->E2pBuf));
			} else if ((gScannedChipid >> 16) == REV_CHIP_ID_9514) {
				stringOffset = ((int)(eeprom->format9514.UnicodeStr) - (int)(eeprom->E2pBuf)); 
			} else if (((gScannedChipid >> 16) == REV_CHIP_ID_9530)||
			           ((gScannedChipid >> 16) == REV_CHIP_ID_9530_) ||
			           ((gScannedChipid >> 16) == REV_CHIP_ID_89530)||
			           ((gScannedChipid >> 16) == REV_CHIP_ID_89530_)
			           ) {
				stringOffset = ((int)(eeprom->format9530.UnicodeStr) - (int)(eeprom->E2pBuf)); 
			} else if (((gScannedChipid >> 16) == REV_CHIP_ID_9730)|| ((gScannedChipid >> 16) == REV_CHIP_ID_9730_)){
				stringOffset = ((int)(eeprom->format9730.UnicodeStr) - (int)(eeprom->E2pBuf)); 
			}
			retVal = GenerateStringField(&content, eeprom, stringOffset);
			if(retVal == ERROR_FAIL) {
				retVal = ERROR_FAIL;
				goto _EXIT;
			}
		}else{
			for ( i = 0, offset = eeprom->format.SerialNumberStrOffset+1;   serialNumber[i] != '\0';   i++, offset++ )
				eeprom->WBuf[offset] = (WORD)serialNumber[i];
		}

	} else {
		eeprom->format.SerialNumberStrLen = 0;
		eeprom->format.SerialNumberStrOffset = 0;
	}

_EXIT:
	CleanEEPROMStruct(&content);
	return retVal;
}

int VerifyOptions(PEEPROM_CONTENT pContent)
{
	int retVal = SUCCESS;
	E2P_STRUCT e2p;
	FILE *fEeprom = NULL;
	int eeprom_len, i;
	char * binFile;

	if(pContent->action == 	CMD_NULL){
		PRINT_ERROR("One of options -w, -r should be declared\n");
		retVal = ERROR_FAIL;
		return retVal;
	}

	if(pContent->eepromFileName){
		switch(pContent->action){
		case CMD_WRITE:
		case CMD_VERIFY:

			if(pContent->loop || pContent->saveNext){
		    	if(field[FIELD_MAC_INC] == FIELDRESULT_EMPTY){
		    		PRINT_ERROR("Mac address increment is missing\n");
		    		retVal = ERROR_FAIL;
		    	}
		    	if(field[FIELD_SERIAL_INC] == FIELDRESULT_EMPTY){
		    		PRINT_ERROR("Serial number increment is missing\n");
		    		retVal = ERROR_FAIL;
		    	}
		    	if(retVal == ERROR_FAIL)goto _EXIT;
			}

			
			binFile = (char*)malloc(MAX_CHAR);
			if(!binFile){
    			PRINT_ERROR("No enough memory\n");
    		    retVal= ERROR_NOMEM;
    		    goto _EXIT;
    		}

			strcpy(binFile,CurrentFolder);
			strcat(binFile,pContent->eepromFileName);

			fEeprom = fopen(binFile, "rb");
			if(!fEeprom){
				PRINT_ERROR("No file %s is found\n", pContent->eepromFileName);
				retVal = ERROR_FAIL;	
				goto _EXIT;
			}
			eeprom_len = fread(&e2p, 1, sizeof(E2P_STRUCT), fEeprom);
			if(eeprom_len < 32){
				PRINT_ERROR("No enough bytes in file %s\n", pContent->eepromFileName);
				retVal = ERROR_FAIL;
				goto _EXIT;
			}

			if(!pContent->curMacValid){//Get it from binary file
				memcpy(pContent->curMacAddr, e2p.format.MacAddr, 6);
				field[FIELD_CUR_MAC] = FIELDRESULT_OK;
				pContent->curMacValid = TRUE;
			}

			// Set max mac address if bin file
			memset(pContent->maxMacAddr, 0xFF, 6);
			pContent->maxMacAddr[5] = 0xFE;
			field[FIELD_MAX_MAC] = FIELDRESULT_OK;

			if(!pContent->curSerialNum){//Get it from binary file
				if(e2p.format.SerialNumberStrLen){
					pContent->curSerialNum = (char*)malloc(e2p.format.SerialNumberStrLen/2);
					if(!pContent->curSerialNum){
						PRINT_ERROR("No enough memory\n");
						retVal = ERROR_FAIL;
						goto _EXIT;
					}
					for(i=0; i<(e2p.format.SerialNumberStrLen/2-1); i++)
						pContent->curSerialNum[i] = (char)e2p.WBuf[e2p.format.SerialNumberStrOffset + 1 + i];
					pContent->curSerialNum[(int)(e2p.format.SerialNumberStrLen/2-1)] = '\0';

					if(convertToCapital(pContent->curSerialNum) != SUCCESS){
						PRINT_ERROR("The serial number is not Hex digit\n");
						retVal = ERROR_FAIL;
						goto _EXIT;
					}else if(strlen(pContent->curSerialNum) > MAX_SERIAL_LEN){
						PRINT_ERROR("Current serial number size is greater than %d\n",MAX_SERIAL_LEN);
						retVal = ERROR_FAIL;
						goto _EXIT;
					}else{
						field[FIELD_CUR_SERIAL] = FIELDRESULT_OK;
					}
				}
			}

			if(!pContent->curSerialNum){
				if(pContent->loop){
					PRINT_ERROR("Serial number field is null in binary file, couldn't be increased\n");
					retVal = ERROR_FAIL;
					goto _EXIT;
				}
			}
			break;
		case CMD_READ:
			goto _EXIT;
			break;
		}
	}else{
		if(pContent->action != CMD_READ){
			PRINT_ERROR("Binary file(-b) should be provided\n");
			retVal = ERROR_FAIL;
			goto _EXIT;
		}else{
			goto _EXIT;
		}
	}

	if(field[FIELD_CUR_MAC] == FIELDRESULT_INVALID){
		PRINT_ERROR("Invalid current mac address\n");
		retVal = ERROR_FAIL;
		goto _EXIT;
	}else if(field[FIELD_CUR_MAC] == FIELDRESULT_EMPTY){
		PRINT_ERROR("Current mac address is missing\n");
		retVal = ERROR_FAIL;
		goto _EXIT;
	}else{
		/*Verify mac address, it is not broadcast , multicast and all zeros*/
		if(!VerifyMacRange(pContent->curMacAddr)){
			PRINT_ERROR("Invalid current mac address\n");
			retVal = ERROR_FAIL;
			goto _EXIT;
		}
	}

	if(cmpMac(pContent->curMacAddr, pContent->maxMacAddr, 6) > 0){
		PRINT_ERROR("Current MAC address is greater than maximum MAC address\n");
		retVal = ERROR_FAIL;
		goto _EXIT;
	}

	if(field[FIELD_MAC_INC] == FIELDRESULT_INVALID){
		PRINT_ERROR(" Invalid mac address increment or out of range\n");
		retVal = ERROR_FAIL;
	}

	if(retVal == ERROR_FAIL)goto _EXIT;

	if(pContent->curSerialNum && pContent->maxSerialNum){
		int curLen, maxLen;
		int diff;
		char* tmpStr;
		curLen = strlen(pContent->curSerialNum);
		maxLen = strlen(pContent->maxSerialNum);

		diff = curLen - maxLen;
		if(diff > 0){
			tmpStr = (char*)malloc(curLen+1);
			if(!tmpStr){
				PRINT_ERROR("No enough memory\n");
				retVal = ERROR_FAIL;
				goto _EXIT;
			}
			memset(tmpStr, '0', diff);
			strcpy(&tmpStr[diff], pContent->maxSerialNum);
			free(pContent->maxSerialNum);
			pContent->maxSerialNum = tmpStr;
		}else if(diff < 0){
			tmpStr = (char*)malloc(maxLen+1);
			if(!tmpStr){
				PRINT_ERROR("No enough memory\n");
				retVal = ERROR_FAIL;
				goto _EXIT;
			}

			memset(tmpStr, '0', -diff);
			strcpy(&tmpStr[-diff], pContent->curSerialNum);
			free(pContent->curSerialNum);
			pContent->curSerialNum = tmpStr;
		}

	}

	if(pContent->curSerialNum && pContent->maxSerialNum){
		if(strcmp(pContent->curSerialNum, pContent->maxSerialNum) > 0){
			PRINT_ERROR("Current serial number is greater than maximum serial number\n");
			retVal = ERROR_FAIL;
			goto _EXIT;
		}
	}

	if(field[FIELD_SERIAL_INC] == FIELDRESULT_INVALID){
		PRINT_ERROR(" Invalid serial number increment or out of range\n");
		retVal = ERROR_FAIL;
		goto _EXIT;
	}

_EXIT:
	
	if(fEeprom)fclose(fEeprom);
	if (binFile) free(binFile);
	return retVal;
}

char * iam = NULL;

void DisplayUsage(void)
{
	printf("Usage: %s -b <bin_filename> (-w -r) [-M <mac_address> -S <serial_num> -m <mac_increment> -s <serial_increment>] [-N] [-h]\n",iam);
	printf("Usage: %s [-R <register address read>] [-W <register address write> [-v <value to write>]>\n",iam);
	printf("Usage: %s -n <phy address> [-y <phy register index to read>] [-Y <phy register index to write>] [-v <value to write>]>\n",iam);
	printf("-b <bin_filename> binary file to write to the EEPROM \n");
	printf("-w                Write the EEPROM Contents.\n");
	printf("-r                Read the EEPROM Contents to a binary file\n");
	printf("-M <mac_address>  Overrides the mac address\n");
	printf("-m <mac_increment> Overrides the increment for the mac address.\n");
	printf("-S <serial_num>	   Overrides the serial number\n");
	printf("-s <serial_increment> Overrides the increment for the serial number\n");
	printf("-N               Update bin file with next mac address and serial number\n");
	printf("-h               Displays this usage information, other options ignored.\n");
    printf("-R <Register address in hex> Read Control and Status register\n");
    printf("-W <Register address in hex> -v <hex value> Write Control and Status register\n");
    printf("-n <phy address> -y <PHY Register index in hex> Read PHY register\n");
    printf("-n <phy address> -Y <PHY Register index in hex> -v <hex value> Write PHY register\n");
	//printf("-n <phy address> -z <SMI Register address in hex> Read PHY register\n");
    //printf("-n <phy address> -Z <SMI Register address in hex> -v <hex value> Write PHY register\n");
}

int Init(int argc, char *argv[], PEEPROM_CONTENT pContent)
{
	int ret = SUCCESS;
	int opt;
	int cnt = 1;
	char *optStr;
	unsigned char curMacAddr[6] = {0, 0, 0, 0, 0, 0};
	int curMacValid = FALSE;
	char *curSerialNum = NULL;
	int opt_serial_inc = 0;
	int opt_mac_inc = 0;
	int PhyAddressValid = FALSE;

    iam = argv[0];
	memset(pContent, 0, sizeof(EEPROM_CONTENT));
	memset(field,0,sizeof(field));
	pContent->eeprom_size = MAX_EEPROM_SIZE;
	pContent->FullSpeedPollingInterval = DEFAULT_FULLSPPED_POLL;
	pContent->HighSpeedPollingInterval = DEFAULT_HIGHSPPED_POLL;
	pContent->VendorID = USB_VENDOR_ID_SMSC;
	pContent->ProductID = USB_PRODUCT_ID_SMSC_THERA;

    while((ret == SUCCESS) && (opt = getOpt(argc, argv, &cnt, &optStr))){
    	switch(opt){
    	case 'b':
    		if(optStr){
    			    			
    				pContent->eepromFileName = (char*)malloc(strlen(optStr) + 1);
    				if(!pContent->eepromFileName){
    					PRINT_ERROR("No enough memory\n");
    				    ret = ERROR_NOMEM;
    				    break;
    				 }
    				strcpy(pContent->eepromFileName, optStr);
    			
    		}else{
    			PRINT_ERROR("No binary file name is specified \n");
    			ret = ERROR_PARAMETER;
    		}
    		break;
    	
    	case 'w': //command to program eeprom
    		if(pContent->action != CMD_NULL){
    			PRINT_ERROR("Only one of options(-w, -r,) could be specified \n");
    			ret = ERROR_PARAMETER;
    		}else{
    			pContent->action = CMD_WRITE;
    		}
    		break;
    	case 'r': //command to read eeprom
       		if(pContent->action != CMD_NULL){
        		PRINT_ERROR("Only one of options(-w, -r,) could be specified \n");
        		ret = ERROR_PARAMETER;
        	}else{
        		pContent->action = CMD_READ;
        	}
    		break;
    	
    	case 'M': //Overwrites the mac address in the binary or init file
    		if(optStr){
    			if(GetMacAddr(curMacAddr, optStr) < 0){
    				field[FIELD_CUR_MAC] = FIELDRESULT_INVALID;
    				PRINT_ERROR("Invalid Mac address\n");
    				ret = ERROR_PARAMETER;
    			}else{
    				field[FIELD_CUR_MAC] = FIELDRESULT_OK;
    				curMacValid = TRUE;
    			}
    		}else{
    			PRINT_ERROR("Mac address should be specified after option -M\n");
    			ret = ERROR_PARAMETER;
    		}
    		break;
    	case 'm':
			if(optStr){
				if(SanityCheckDecimal(optStr, MAX_INC_DIGIT) != SUCCESS){
					PRINT_ERROR("Invalid Mac address increment with -m option\n");
    				ret = ERROR_PARAMETER;
    				break;
				}else{
					sscanf(optStr, "%d", &opt_mac_inc);
				}
			}else{
				opt_mac_inc = 1;
			}
    		break;
    	case 'S': //Overwrites the serial number in the binary or init file
    		if(optStr){
    			curSerialNum =  (char*)malloc(strlen(optStr) + 1);
    			if(!curSerialNum){
    				PRINT_ERROR("No enough memory\n");
    				ret = ERROR_NOMEM;
    				break;
    			}
    			strcpy(curSerialNum, optStr);
    		}else{
    			PRINT_ERROR("Serial number should be specified after option -S\n");
    			ret = ERROR_PARAMETER;
    		}
			break;
    	case 's':
			if(optStr){
				if(SanityCheckDecimal(optStr, MAX_INC_DIGIT) != SUCCESS){
					PRINT_ERROR("Invalid serial number increment with -s option\n");
    				ret = ERROR_PARAMETER;
    				break;
				}else{
					sscanf(optStr, "%d", &opt_serial_inc);
				}
			}else{
				opt_serial_inc = 1;
			}
    		break;
    	
    	case 'N': //Save next serial number and MAC address in the file
    		pContent->saveNext = TRUE;
//			if (opt_mac_inc <=0)
//				opt_mac_inc = 1;
//			if (opt_serial_inc <=0)
//				opt_serial_inc = 1;
    		break;

     	case 'n':
			if (optStr) {
				if (!HexStrToDword(optStr, &pContent->phyAddress)) {
					ret = ERROR_PARAMETER;
					break;
				}
				if ((pContent->phyAddress < 0) || (pContent->phyAddress > 31)) {
					PRINT_ERROR("Invalid phy address\n");
    				ret = ERROR_PARAMETER;
    				break;
				}
				PhyAddressValid = TRUE;
			} else {
                    PRINT_ERROR("Phy address need to be specified\n");
                    ret = ERROR_PARAMETER;
			}
            break;

        case 'R': //command to read control and status register      
            if(pContent->action != CMD_NULL){
                PRINT_ERROR("Only one of options could be specified\n");
                ret = ERROR_PARAMETER;
            }else {
                pContent->action = CMD_READ_REG;
                if (optStr) {
                    if (!HexStrToDword(optStr, &pContent->registerAddress)) {
                        ret = ERROR_PARAMETER;
                    }
                } else {
                    PRINT_ERROR("Register address need to be specified\n");
                    ret = ERROR_PARAMETER;
                }
            }
            break;
        case 'W': //command to write control and status register
            if(pContent->action != CMD_NULL){
                PRINT_ERROR("Only one of options could be specified \n");
                ret = ERROR_PARAMETER;
            }else{
                pContent->action = CMD_WRITE_REG;
                if (optStr) {
                    if (!HexStrToDword(optStr, &pContent->registerAddress)) {
                        ret = ERROR_PARAMETER;
                    }
                } else {
                    PRINT_ERROR("Register address need to be specified\n");
                    ret = ERROR_PARAMETER;
                }
            }
            break;
        case 'y': //command to Read Phy register
            if(pContent->action != CMD_NULL){
                PRINT_ERROR("Only one of options could be specified \n");
                ret = ERROR_PARAMETER;
            }else{
                pContent->action = CMD_READ_PHY;
                if (optStr) {
                    if (!HexStrToDword(optStr, &pContent->registerAddress)) {
                        ret = ERROR_PARAMETER;
                    }
                } else {
                    PRINT_ERROR("Phy Register index need to be specified for read\n");
                    ret = ERROR_PARAMETER;
                }
            }
            break; 
        case 'Y': //command to write cphy register     
            if(pContent->action != CMD_NULL){
                PRINT_ERROR("Only one of options could be specified \n");
                ret = ERROR_PARAMETER;
            }else{
                pContent->action = CMD_WRITE_PHY;
                if (optStr) {
                    if (!HexStrToDword(optStr, &pContent->registerAddress)) {
                        ret = ERROR_PARAMETER;
                    }
                } else {
                    PRINT_ERROR("Phy Register index need to be specified write\n");
                    ret = ERROR_PARAMETER;
                }
            }
            break; 
        case 'v': //value to write to CSR or phy register
        
            if(pContent->dataValueValid){
                PRINT_ERROR("Value already specified\n");
                ret = ERROR_PARAMETER;
            }else{
                if (optStr) {
                    pContent->dataValueValid = TRUE;
                    if (!HexStrToDword(optStr, &pContent->dataValue)) {
                        ret = ERROR_PARAMETER;
                    }
                } else {
                    PRINT_ERROR("Value missing\n");
                    ret = ERROR_PARAMETER;
                }
            }
            break;
        case 'z': //command to Read Phy register
            if(pContent->action != CMD_NULL){
                PRINT_ERROR("Only one of options could be specified \n");
                ret = ERROR_PARAMETER;
            }else{
                pContent->action = CMD_READ_PHY_SMI;
                if (optStr) {
                    if (!HexStrToDword(optStr, &pContent->registerAddress)) {
                        ret = ERROR_PARAMETER;
                    }
                } else {
                    PRINT_ERROR("SMI Register address need to be specified for read\n");
                    ret = ERROR_PARAMETER;
                }
            }
            break; 
        case 'Z': //command to write cphy register     
            if(pContent->action != CMD_NULL){
                PRINT_ERROR("Only one of options could be specified \n");
                ret = ERROR_PARAMETER;
            }else{
                pContent->action = CMD_WRITE_PHY_SMI;
                if (optStr) {
                    if (!HexStrToDword(optStr, &pContent->registerAddress)) {
                        ret = ERROR_PARAMETER;
                    }
                } else {
                    PRINT_ERROR("SMI Register address need to be specified write\n");
                    ret = ERROR_PARAMETER;
                }
            }
            break; 
    	case 'h':
		default:
    		DisplayUsage();
    		ret = SUCCESS_DONE;
    		return ret;
		}
    }


	if ((pContent->action == CMD_NULL)) {
		DisplayUsage();
		ret = ERROR_FAIL;
		return ret;
	}

	if ((pContent->action == CMD_READ)) {
		goto Exit_Init;
	}

	if (((pContent->action == CMD_READ_REG) || (pContent->action == CMD_READ_PHY)) && (pContent->dataValueValid == TRUE)) {
        PRINT_ERROR("Invalid parameters: do not specify -v option\n");
        ret = ERROR_PARAMETER;
        return ret;
    }

	if (((pContent->action == CMD_READ_PHY) || (pContent->action == CMD_WRITE_PHY)) && (PhyAddressValid != TRUE)) {
			PRINT_ERROR("No phy address specified. please use -n option\n");
			ret = ERROR_PARAMETER;
			return ret;
    }

    if (((pContent->action == CMD_WRITE_REG) || (pContent->action == CMD_WRITE_PHY) || 
		(pContent->action == CMD_WRITE_PHY_SMI)) && (pContent->dataValueValid != TRUE)) {
        PRINT_ERROR("Invalid parameters: need to specify -v option\n");
        ret = ERROR_PARAMETER;
        return ret;
    }
	if (((pContent->action == CMD_READ_PHY_SMI) || (pContent->action == CMD_WRITE_PHY_SMI)) && (PhyAddressValid != TRUE)) {
			PRINT_ERROR("No phy address specified. please use -n option\n");
			ret = ERROR_PARAMETER;
			return ret;
    }

	if ((pContent->action == CMD_READ_REG) || (pContent->action == CMD_READ_PHY) || 
		(pContent->action == CMD_WRITE_REG) || (pContent->action == CMD_WRITE_PHY) ||
		(pContent->action == CMD_READ_PHY_SMI) || (pContent->action == CMD_WRITE_PHY_SMI)) {
        return ret;
    }

	if ((pContent->action == CMD_WRITE) && (!pContent->eepromFileName)) {
		PRINT_ERROR("file name must be specified (-b binary file) after option -w\n");
		ret = ERROR_PARAMETER;
		return ret;
	}


	if ((pContent->action == CMD_WRITE) && (!pContent->saveNext) && (opt_mac_inc || opt_serial_inc))   {
		PRINT_ERROR("Must specify -N option with -m and/or -s \n");
		ret = ERROR_PARAMETER;
		return ret;
	}


	if (ret != SUCCESS) {
		return ret;
	}
			
    if(ret == SUCCESS && pContent->action != CMD_READ){
    	if(curMacValid){
    		memcpy(pContent->curMacAddr, curMacAddr, 6);
    		pContent->curMacValid = TRUE;
    		field[FIELD_CUR_MAC] = FIELDRESULT_OK;
    	}
    	if(curSerialNum){
			if(convertToCapital(curSerialNum) != SUCCESS){
				PRINT_ERROR("Current serial number is not Hex digit\n");
				field[FIELD_CUR_SERIAL] = FIELDRESULT_INVALID;
				ret = ERROR_PARAMETER;
			}else if(strlen(curSerialNum) > MAX_SERIAL_LEN){
				PRINT_ERROR("Current serial number size is greater than %d\n",MAX_SERIAL_LEN);
				field[FIELD_CUR_SERIAL] = FIELDRESULT_INVALID;
				ret = ERROR_PARAMETER;
			}else{
	    		if(pContent->curSerialNum)free(pContent->curSerialNum);
	    		pContent->curSerialNum = (char*)malloc(strlen(curSerialNum) + 1);
	    		if(!pContent->curSerialNum){
	    			PRINT_ERROR("No enough memory\n");
	    			ret = ERROR_NOMEM;
	    		}else{
	    			strcpy(pContent->curSerialNum, curSerialNum);
	    			field[FIELD_CUR_SERIAL] = FIELDRESULT_OK;
	    		}
			}
    	}

		if ((pContent->saveNext) && (opt_mac_inc<=0)) {
		    PRINT_MSG("Mac address increment must be greater than zero, set to 1 \n");
		    opt_mac_inc=1;
	    }

	    if ((pContent->saveNext) && (opt_serial_inc<=0)) {
		    PRINT_MSG("serial number increment must be greater than zero, set to 1 \n");
		    opt_serial_inc=1;
	    }

		
    	if(opt_mac_inc != 0){
    		pContent->macIncrement = opt_mac_inc;
			if(pContent->macIncrement < 0){
				PRINT_ERROR("Mac address increment cannot be less than zero\n");
				ret = ERROR_PARAMETER;
			}else if(pContent->macIncrement > MAX_INCREMENT){
				PRINT_ERROR("Mac address increment cannot exceed %d\n", MAX_INCREMENT);
				ret = ERROR_PARAMETER;
			}else{
				field[FIELD_MAC_INC] = FIELDRESULT_OK;
			}
    	}
    	if(opt_serial_inc != 0){
    		pContent->serialIncrement = opt_serial_inc;
			if(pContent->serialIncrement < 0){
				PRINT_ERROR("Serial number increment cannot be less than zero\n");
				ret = ERROR_PARAMETER;
			}else if(pContent->serialIncrement > MAX_INCREMENT){
				PRINT_ERROR("Serial number increment cannot exceed %d\n", MAX_INCREMENT);
				ret = ERROR_PARAMETER;
			}else{
				field[FIELD_SERIAL_INC] = FIELDRESULT_OK;
			}
			if(pContent->eepromFileName){// Set max serial address if bin file
				field[FIELD_MAX_SERIAL] = FIELDRESULT_OK;
			}
    	}

    	if(ret == SUCCESS)
    		ret = VerifyOptions(pContent);
    }

Exit_Init:
    if(curSerialNum)
		free(curSerialNum);

    return ret;
}

// returns number of TCHARs in string 
int wstrlen(_TCHAR * wstr)
{     
      int l_idx = 0;
      while (((char*)wstr)[l_idx]!=0)
	  	l_idx+=2;     
	  return l_idx; 
}   

// Allocate char string and copy TCHAR->char->string 
char * wstrdup(_TCHAR * wSrc) 
{     int l_idx=0;     
      int l_len = wstrlen(wSrc);   
      char * l_nstr = (char*)malloc(l_len); 
      if (l_nstr) {       
	      do {          
		          l_nstr[l_idx] = (char)wSrc[l_idx];   
		          l_idx++;         
		} while ((char)wSrc[l_idx]!=0);  
	  }   
     l_nstr[l_idx] = 0;    
     return l_nstr; 
} 

// allocate argn structure parallel to argv 
// argn must be released 

char ** allocate_argn (int argc, _TCHAR* argv[])
{     
     char ** l_argn = (char **)malloc(argc * sizeof(char*));  
     for (int idx=0; idx<argc; idx++) 
	  {         
	     l_argn[idx] = wstrdup(argv[idx]);   
	  }   
      return l_argn;
}


// release argn and its content 
void release_argn(int argc, char ** nargv)
{     
     for (int idx=0; idx<argc; idx++)
         free(nargv[idx]);     
     free(nargv);
}   

int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE hAdapter;
	char Buffer[1024];
	PTCHAR pAdapterName;
	DWORD dwOutSize,ChipId;
	PNDISUIO_QUERY_BINDING pQueryBinding;
	PNDISUIO_QUERY_OID queryOID;
	UCHAR QueryBuffer[sizeof(NDISUIO_QUERY_OID)+sizeof(DWORD)];
	BOOL LoopEndFlag = FALSE;	
	DWORD NofBytes = 0, E2pSize=0; 
	int i = 0, key = 0, retVal = SUCCESS;
	DRIVER_VERSION DrvVer;
	BYTE readBuf[516], writeBuf[516];
	PEEPROM_CONTENT pContent;
	E2P_STRUCT eeprom;
	FILE *fEeprom;
	DWORD regVal = 0;
    DWORD phyRegVal = 0;
	char *filename, *Tempname, *binFileR, *binFileW;
	WCHAR *wszTemp = NULL;
	WCHAR  wszDirectory[MAX_CHAR] = L"\0";
	char ** argn = allocate_argn(argc, argv); 
		
	GetModuleFileNameW(NULL,wszDirectory,MAX_CHAR);
		 
	wszTemp = wcsrchr(wszDirectory,L'\\'); // Finds last occurence and replace it with NULL.	 
	*(wszTemp+1) = L'\0';

	Tempname = wstrdup(wszDirectory);

	strcpy(CurrentFolder, Tempname);
			
	if (Tempname) 
		free(Tempname);
	
	pContent = (EEPROM_CONTENT *)malloc(sizeof(EEPROM_CONTENT));
	mem_set(pContent, 0, sizeof(EEPROM_CONTENT));
	mem_set(field, 0, sizeof(field));

	pContent->eeprom_size = MAX_EEPROM_SIZE;
	pContent->FullSpeedPollingInterval = DEFAULT_FULLSPPED_POLL;
	pContent->HighSpeedPollingInterval = DEFAULT_HIGHSPPED_POLL;
	pContent->VendorID = USB_VENDOR_ID_SMSC;
	pContent->ProductID = USB_PRODUCT_ID_SMSC_THERA;
	
	retVal = Init(argc, argn, pContent);

	release_argn(argc, argn); 
		
	if (retVal == SUCCESS_DONE) {
		if(pContent)
			free(pContent);
			return 0;
	}
			
	if (retVal != SUCCESS) 
	{
		if (pContent) 
			free(pContent);
		PRINT_ERROR("Parameter Error (use -h for help)\n");
		return 0;
	}
	
	hAdapter = CreateFile(TEXT("UIO1:"), 0x00, 0x00, NULL, OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,
				INVALID_HANDLE_VALUE);
		
	if (hAdapter == INVALID_HANDLE_VALUE) {
		wprintf (L"\nCE9500eep: Invalid hAdapter\n\n");
		goto Exit_WinMain;
	}
	pQueryBinding = (PNDISUIO_QUERY_BINDING)&Buffer[0];	
	memset(pQueryBinding, 0x00, sizeof(NDISUIO_QUERY_BINDING));
	
	pQueryBinding->BindingIndex = 0;
		
	while (TRUE) {		
		if (!DeviceIoControl(hAdapter,
				IOCTL_NDISUIO_QUERY_BINDING, pQueryBinding,
				sizeof(NDISUIO_QUERY_BINDING),
				pQueryBinding, 1024, &dwOutSize, NULL))  {
				wprintf (L"\nError at IOCTL_NDISUIO_QUERY_BINDING, GetLastError()= %d\n",GetLastError());
				goto Exit_WinMain;
		}
			
		pAdapterName = (PTCHAR)&Buffer[pQueryBinding->DeviceNameOffset];	
		pAdapterName[(pQueryBinding->DeviceNameLength / sizeof(TCHAR)) - 1] = 0x00;
		if (!wcscmp((const wchar_t *)pAdapterName, (const wchar_t *)L"SMSC95001"))
			break;
		pQueryBinding->BindingIndex++;
	}
	
	wprintf (L"NDISPWR:: Found adapter [%s]\r\n",pAdapterName);
				
	queryOID = (PNDISUIO_QUERY_OID)&QueryBuffer[0];
	queryOID->ptcDeviceName = pAdapterName;
#if 0	
	if (!GetDriverVersion(hAdapter, queryOID,(void *)&DrvVer.Major)) {
		goto Exit_WinMain;
	}
	
	if (!LanReadRegDW(hAdapter, queryOID, ETH_ID_REV, &ChipId)) {
		goto Exit_WinMain;
	}
	
	gScannedChipid = ChipId;
	
	printf ("Driver Version: V%d.%d.%04d.%04d\n", DrvVer.Major, DrvVer.Minor, DrvVer.Build, DrvVer.Qfe);
	printf ("Chip ID: 0x%x\n", ChipId);
	printf ("Application Version V%d.%d (%s)\n", MAJOR_VER, MINOR_VER, DATECODE);
	printf ("Built at %s on %s)\n\n\n",  __TIME__, __DATE__);
#endif	
	if ((pContent->action == CMD_READ) || (pContent->action == CMD_WRITE)) {
		if (!GetE2pSize(hAdapter, queryOID, &E2pSize)) {
			PRINT_ERROR("Couldn't get Eeprom Size\n");
			goto Exit_WinMain;
		}
		pContent->eeprom_size = E2pSize;
	}

	if (pContent->action == CMD_READ) {	
		memset((void *)readBuf,0,sizeof(readBuf));
			
		if (ReadBlockE2p(hAdapter, queryOID, E2pSize, readBuf) == FALSE) {
				PRINT_ERROR("Read Eeprom Block Failed\n");
				goto Exit_WinMain;
		}

		filename = "lan9500.bin";
			
		binFileR = (char*)malloc(MAX_CHAR);
		if (!binFileR) {
			PRINT_ERROR("No enough memory\n");
			goto Exit_WinMain;
		}

		strcpy(binFileR, CurrentFolder);
			
		if (pContent->eepromFileName)
			strcat(binFileR, pContent->eepromFileName);
		else
			strcat(binFileR,filename);
	
		fEeprom = fopen(binFileR, "w+b");
		if (!fEeprom) {
			PRINT_ERROR("Couldn't create file %s\n", binFileR);
			goto Exit_WinMain;
		} else {
			fwrite(readBuf + 4, 1, E2pSize, fEeprom);
			fclose(fEeprom);
		}			
		PRINT_MSG("Saved Eeprom to the file %s under current folder\n",(pContent->eepromFileName ? pContent->eepromFileName : filename));	

	} else if (pContent->action == CMD_WRITE) {
		BYTE *pBuf = writeBuf;						
		// Clear memory
		memset(writeBuf, 0x00, sizeof(writeBuf));
		memset((void *)eeprom.E2pBuf, 0, sizeof(E2P_STRUCT));
					
		binFileW = (char*)malloc(MAX_CHAR);
		if (!binFileW) {
			PRINT_ERROR("No enough memory\n");
			goto Exit_WinMain;
		}

		strcpy(binFileW,CurrentFolder);
		strcat(binFileW,pContent->eepromFileName);
	
		fEeprom = fopen(binFileW, "rb");
		if (!fEeprom) {
			PRINT_ERROR("No file %s was found\n", binFileW);		
			goto Exit_WinMain;
		}
		pContent->real_size = fread(&eeprom, 1, E2pSize, fEeprom);
		fclose(fEeprom);
											
		if(pContent->real_size > pContent->eeprom_size){
			PRINT_ERROR("The size of binary file is greater than eeprom size\n");						
			goto Exit_WinMain;
		}

		if (ModifyEEPROMImage(&eeprom, pContent->curMacAddr, pContent->curSerialNum, pContent->eeprom_size) != SUCCESS) {
			PRINT_ERROR("Modified EEPROM image failed.\n");					
			goto Exit_WinMain;
		}					

		for (int i=0; i<pContent->real_size; i++)
			writeBuf[i+4] = eeprom.E2pBuf[i];

		*(DWORD *)pBuf = E2pSize;	
										
		if(!WriteBlockE2p(hAdapter, queryOID, E2pSize, writeBuf)) {
			PRINT_MSG("Failed to program device eeprom\n");				
			goto Exit_WinMain;
		} else {
			retVal = VerifyEeprom(writeBuf, pContent->eeprom_size,queryOID, hAdapter);
			if(retVal != SUCCESS){
				PRINT_ERROR("Failed to verify device eeprom\n");		
				goto Exit_WinMain;
			} else {
				PRINT_MSG("The current device was programmed,E2p size is %d\n\n\n",E2pSize);							
			}
		}
	}					
						
	if (pContent->saveNext && (pContent->action == CMD_WRITE)) {
		if (!UpdateIncrement(pContent)) {
			PRINT_ERROR("Couldn't increase any Mac or serial number.\n");
			goto Exit_WinMain;
		}	 
				
		if (ModifyEEPROMImage(&eeprom, pContent->curMacAddr, pContent->curSerialNum, pContent->eeprom_size) != SUCCESS) {
			PRINT_ERROR("Modified EEPROM image failed.\n");
			goto Exit_WinMain;
		}
				
		if (pContent->eepromFileName) {//Update eeprom file										
			fEeprom = fopen(binFileW, "w+b");
			if (!fEeprom) {
				PRINT_ERROR("Couldn't create file %s\n", pContent->eepromFileName);
				goto Exit_WinMain;
			} else {
				fwrite(eeprom.E2pBuf, 1, pContent->eeprom_size, fEeprom);
				fclose(fEeprom);	
			}
		}						 
	}
    if (pContent->action == CMD_READ_REG) {
        LanReadRegDW(hAdapter, queryOID, pContent->registerAddress, &regVal);
        printf("Register 0x%x : 0x%x\n", pContent->registerAddress, regVal);

    } else if (pContent->action == CMD_READ_PHY) {
        PhyReadAddressRegW(hAdapter, queryOID, pContent->phyAddress, pContent->registerAddress, &phyRegVal);
        printf("PHY Register 0x%x : 0x%x\n", pContent->registerAddress, phyRegVal);

    } else if (pContent->action == CMD_WRITE_REG) {
		printf("Register address: 0x%x value:0x%x\n",pContent->registerAddress, pContent->dataValue);
        LanWriteRegDW(hAdapter, queryOID, pContent->registerAddress, &pContent->dataValue);
        LanReadRegDW(hAdapter, queryOID, pContent->registerAddress, &regVal);
        printf("Register 0x%x : 0x%x\n",pContent->registerAddress, regVal);

    } else if (pContent->action == CMD_WRITE_PHY) {
        PhyWriteAddressRegW(hAdapter, queryOID, pContent->phyAddress, pContent->registerAddress, &pContent->dataValue);
        PhyReadAddressRegW(hAdapter, queryOID, pContent->phyAddress, pContent->registerAddress, &phyRegVal);
        printf("PHY Register 0x%x : 0x%x\n", pContent->registerAddress, phyRegVal);

    } else if (pContent->action == CMD_READ_PHY_SMI) {
        SMIPhyReadAddressRegW(hAdapter, queryOID, pContent->phyAddress, pContent->registerAddress, &phyRegVal);
        printf("Register 0x%x : 0x%08x\n", pContent->registerAddress, phyRegVal);

    } else if (pContent->action == CMD_WRITE_PHY_SMI) {
        SMIPhyWriteAddressRegW(hAdapter, queryOID, pContent->phyAddress, pContent->registerAddress, &pContent->dataValue);
        SMIPhyReadAddressRegW(hAdapter, queryOID, pContent->phyAddress, pContent->registerAddress, &phyRegVal);
        printf("Register 0x%x : 0x%08x\n", pContent->registerAddress, phyRegVal);

    }	 
				
Exit_WinMain:
	if(pContent) free(pContent);
	if(binFileR) free(binFileR);
	if(binFileW)free(binFileW);
	CloseHandle(hAdapter);
		
	return 0;	 	
}





