/*++
	Copyright (c) 2008-2009 SMSC. All rights reserved.

	The information contained in this file is confidential and proprietary to
	Standard Microsystems Corporation.  No part of this file may be reproduced
	or distributed, in any form or by any means for any purpose, without the
	express written permission of Standard Microsystems Corporation.

Module Name:
	IoCtl.h
Abstract:
    This module contains structure definitons and funtion prototypes of Ioctl.
Revision History:
	02/17/2009	Initial version.
Notes:
--*/

#ifndef __CRTL_H__
#define __CRTL_H__

#define OID_NDIS_SMSC_LAN_READ_REGS     			0xFF950001U
#define OID_NDIS_SMSC_PHY_READ_REGS     			0xFF950002U
#define OID_NDIS_SMSC_LAN_WRITE_REGS     			0xFF950003U
#define OID_NDIS_SMSC_PHY_WRITE_REGS     			0xFF950004U
#define OID_NDIS_SMSC_DUMP_LAN_REGS     			0xFF950005U
#define OID_NDIS_SMSC_DUMP_MAC_REGS					0xFF950006U
#define OID_NDIS_SMSC_DUMP_PHY_REGS     			0xFF950007U
#define OID_NDIS_SMSC_DUMP_TX_STATS     			0xFF950008U
#define OID_NDIS_SMSC_DUMP_RX_STATS     			0xFF950009U
#define OID_NDIS_SMSC_SAVE_E2P_TO_FILE     			0xFF95000AU
#define OID_NDIS_SMSC_ERASE_E2P     				0xFF95000BU
#define OID_NDIS_SMSC_WRITE_FILE_TO_E2P     		0xFF95000CU
#define OID_NDIS_SMSC_SEND_E2P_COMMAND				0xFF95000DU
#define OID_NDIS_SMSC_READ_E2P						0xFF95000EU
#define OID_NDIS_SMSC_WRITE_E2P						0xFF95000FU
#define OID_NDIS_SMSC_READ_E2P_BLOCK    			0xFF950010U
#define OID_NDIS_SMSC_WRITE_E2P_BLOCK     			0xFF950011U
#define OID_NDIS_SMSC_GET_E2P_SIZE  				0xFF950012U
#define OID_NDIS_SMSC_GET_DRIVER_INFO   			0xFF950013U
#define OID_NDIS_SMSC_ENABLE_DEBUG					0xFF950014U
#define OID_NDIS_SMSC_ENABLE_RESUME					0xFF950015U
#define OID_NDIS_SMSC_PHY_READ_REG_ADDRESS			0xFF950016U
#define OID_NDIS_SMSC_PHY_WRITE_REG_ADDRESS			0xFF950017U
#define OID_NDIS_SMSC_GET_LINK_STATUS				0xFF950018U
#define OID_NDIS_SMSC_SET_LINK_STATUS				0xFF950019U

typedef struct _OID_E2P_STRUCT {
	DWORD E2pSize;           // Do not change the first three fields of the
	BYTE eeprom[512];
} OID_E2P_STRUCT, *POID_E2P_STRUCT;

typedef struct _DRIVER_VERSION_STRUCT {
	DWORD   Major;
	DWORD   Minor;
	DWORD   Build;
	DWORD   Qfe;
} DRIVER_VERSION_STRUCT, *PDRIVER_VERSION_STRUCT;
#endif /* __CRTL_H__ */
